%global with_debug 1

%if 0%{?with_debug}
%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%if ! 0%{?gobuild:1}
%define gobuild(o:) GO111MODULE=off go build -buildmode pie -compiler gc -tags="rpm_crashtraceback ${BUILDTAGS:-}" -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '-Wl,-z,relro -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld '" -a -v -x %{?**};
%endif

%global provider github
%global provider_tld com
%global project buildpacks
%global repo pack
# https://github.com/buildpacks/pack
%global import_path %{provider}.%{provider_tld}/%{project}/%{repo}
%global git0 https://%{import_path}

%global built_tag v0.21.1
%global built_tag_strip %(b=%{built_tag}; echo ${b:1})

Name: %{repo}
Version: 0.21.1
Release: 2%{?dist}
Summary: Convert code into runnable images
License: ASL 2.0
URL: %{git0}
Source0: %{built_tag}-vendor.tar.gz
BuildRequires: golang
BuildRequires: go-rpm-macros
BuildRequires: git
BuildRequires: glib2-devel
BuildRequires: glibc-static
BuildRequires: make
Provides: %{name}cli = %{version}-%{release}
Provides: %{name}-cli = %{version}-%{release}

Provides: bundled(golang(github.com/BurntSushi/toml)) = v0.3.1
Provides: bundled(golang(github.com/Masterminds/semver)) = v1.5.0
Provides: bundled(golang(github.com/Microsoft/hcsshim)) = v0.8.10
Provides: bundled(golang(github.com/apex/log)) = v1.9.0
#Provides: bundled(golang(github.com/buildpacks/imgutil)) = v0.0.0-20210510154637-009f91f52918
Provides: bundled(golang(github.com/buildpacks/lifecycle)) = v0.11.3
Provides: bundled(golang(github.com/containerd/containerd)) = v1.4.1
#Provides: bundled(golang(github.com/containerd/continuity)) = v0.0.0-20200107194136-26c1120b8d41
Provides: bundled(golang(github.com/docker/docker)) = v20.10.7+incompatible
Provides: bundled(golang(github.com/docker/go-connections)) = v0.4.0
Provides: bundled(golang(github.com/ghodss/yaml)) = v1.0.0
Provides: bundled(golang(github.com/golang/mock)) = v1.6.0
Provides: bundled(golang(github.com/google/go-cmp)) = v0.5.6
Provides: bundled(golang(github.com/google/go-containerregistry)) = v0.5.1
Provides: bundled(golang(github.com/google/go-github/v30)) = v30.1.0
Provides: bundled(golang(github.com/heroku/color)) = v0.0.6
Provides: bundled(golang(github.com/mattn/go-colorable)) = v0.1.8
#Provides: bundled(golang(github.com/mitchellh/ioprogress)) = v0.0.0-20180201004757-6a23b12fa88e
Provides: bundled(golang(github.com/moby/sys/mount)) = v0.2.0
#Provides: bundled(golang(github.com/moby/term)) = v0.0.0-20201110203204-bea5bbe245bf
Provides: bundled(golang(github.com/onsi/gomega)) = v1.14.0
Provides: bundled(golang(github.com/opencontainers/image-spec)) = v1.0.1
Provides: bundled(golang(github.com/opencontainers/runc)) = v0.1.1
Provides: bundled(golang(github.com/opencontainers/selinux)) = v1.6.0
Provides: bundled(golang(github.com/pelletier/go-toml)) = v1.9.3
Provides: bundled(golang(github.com/pkg/errors)) = v0.9.1
#Provides: bundled(golang(github.com/sabhiram/go-gitignore)) = v0.0.0-20201211074657-223ce5d391b0
Provides: bundled(golang(github.com/sclevine/spec)) = v1.4.0
Provides: bundled(golang(github.com/sergi/go-diff)) = v1.1.0
Provides: bundled(golang(github.com/sirupsen/logrus)) = v1.7.0
Provides: bundled(golang(github.com/spf13/cobra)) = v1.2.1
Provides: bundled(golang(github.com/willf/bitset)) = v1.1.11
Provides: bundled(golang(github.com/xanzy/ssh-agent)) = v0.3.0
#Provides: bundled(golang(golang.org/x/crypto)) = v0.0.0-20201016220609-9e8e0b390897
Provides: bundled(golang(golang.org/x/mod)) = v0.4.2
#Provides: bundled(golang(golang.org/x/oauth2)) = v0.0.0-20210402161424-2e8d93401602
Provides: bundled(golang(gopkg.in/src-d/go-git.v4)) = v4.13.1
#Provides: bundled(golang(gopkg.in/yaml.v3)) = v3.0.0-20210107192922-496545a6307b


%description
%{name} is a CLI implementation of the Platform Interface Specification
for Cloud Native Buildpacks.

%prep
%autosetup -Sgit -n %{name}-%{built_tag_strip}-vendor

%build
mkdir _build
pushd _build
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s $(dirs +1 -l) src/%{import_path}
popd

mv vendor src

export GOPATH=$(pwd)/_build:$(pwd)
export CGO_CFLAGS="-O2 -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -ffat-lto-objects -fexceptions -fasynchronous-unwind-tables -fstack-protector-strong -fstack-clash-protection -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64"
%ifarch x86_64
export CGO_CFLAGS+=" -m64 -mtune=generic -fcf-protection=full"
%endif
# These extra flags present in %%{optflags} have been skipped for now as they break the build
#export CGO_CFLAGS+=" -flto=auto -Wp,D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1"

%gobuild -o out/%{name} %{import_path}/cmd/%{name}

%install
export GOPATH=$(pwd)/_build:$(pwd):%{gopath}
make DESTDIR=%{buildroot} PREFIX=%{_prefix} install

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}

%changelog
* Mon Sep 20 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.21.1-2
- include metaprovides for packcli and pack-cli

* Sat Sep 18 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> - 0.21.1-1
- autobuilt v0.21.1

* Wed Sep 15 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> - 0.21.0-1
- autobuilt v0.21.0

* Fri Sep 10 2021 RH Container Bot <rhcontainerbot@fedoraproject.org> - 0.21.0-0.1.rc1
- autobuilt v0.21.0-rc1

* Mon Jul 26 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.20.0-2
- Resolves: #1985398 - first build for fedora
- solve rpmlint issues

* Thu Jul 22 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.20.0-1
- Initial package
- debug_package disabled for now, needs to be investigated
